=== debian/changelog ===
open-coarrays (2.10.3-4) unstable; urgency=medium

  * d/gpb.conf: pristine-tar = True
  * disable-tests-2.patch: strided _send-get test compile breaks
    on ICE in gfortran on i386,armhf, other ports. Disable test

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 03 Feb 2026 06:23:39 +0000

open-coarrays (2.10.3-3) unstable; urgency=medium

  * Fix autogenerated files cleanup that was breaking pre/postinst
    generation. Closes: #1125345, #1125316

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 27 Jan 2026 11:45:57 +0000

open-coarrays (2.10.3-2) unstable; urgency=medium

  * powerpcspe now dropped (from mpi-defaults). Upadte d/control
  * Do sourceful upload

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 11 Jan 2026 19:42:00 +0000

open-coarrays (2.10.3-1) unstable; urgency=medium

  * New upstream release. Closes: #1113349, #1097507
  * Update libname patch
  * Standards-Version: 4.7.2
  * Move dh-fortran-mod to dh-fortran
  * Use pre-computed DEB_HOST_MULTIARCH
  * Take mod files from mpich build instead
  * Add debian/salsa-ci.yml file
  * d/watch: Move to version 5 syntax
  * Fix lintian warnings: 
  * Standards-Version: 4.7.3
  * Drop Priority: optional from source in d/control per new policy
  * Add lintian-overrides: lint doesn't know of powerpcspe port in MPI
    defaults

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Jan 2026 17:00:50 +0000
